/*
ATLSWC - AddTLSSection With Code
Copyright (C) 2012  George Nicolaou nicolaou.george{at}gmail{dot}com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#pragma optimize("", off)
#include "include.h"
#include "pe_stuff.h"
#include "memory.h"

unsigned char ucCode[33] = {
	0x56,							// PUSH ESI
	0xE8, 0x00, 0x00, 0x00, 0x00,	// CALL $
	0x5E,							// POP ESI
	0x83, 0xC6, 0x12,				// ADD ESI, 0x12
	0x8B, 0x3E,						// MOV EDI, DWORD [ESI]
	0x83, 0xC6, 0x04,				// ADD ESI, 4
	0xB9, 0x05, 0x00, 0x00, 0x00,	// MOV ECX, 5
	0xF3, 0xA4,						// REP MOVS BYTE PTR ES:[EDI],BYTE PTR DS:[ESI]
	0x5E,							// POP ESI
	0xC3,							// RETN
	0xC5, 0x15, 0x40, 0x00,			// Address to patch to (EP Address) [24]
	0xE8, 0x1E, 0x24, 0x00,	0x00	// Bytes to patch [28]
};

char *GetFileName(char *path)
{
	int iPathLen;
	iPathLen = strlen(path);
	path = path + iPathLen - 1;
	while( *(path) != '\\' && iPathLen ) {
		iPathLen--;
		path--;
	}
	return path+1;
}

void Usage(char *imgname)
{
	printf("/*\nAdd TLS Section of Size (ATLSS) With Code\n\tVersion: v0.1\n\t"
		"Author:George Nicolaou (nicolaou.george{at}gmail{dot}com)\n\tUsage: %s "
		"<executable path> <size of section>\n*/\n",GetFileName(imgname));
}

int main(int argc, char *argv[])
{
	FILE_IN_MEMORY sFile;
	int size;
	char * lpszOutFileName, * lpszOutFileNameTmp, * lpszFileNameTmp;
	void * lpEntry;
	unsigned char * lpRealEntry = NULL;
	int iFilenameSize;
	unsigned char ucBackupBuffer[5];
	PIMAGE_NT_HEADERS psNtHeaders = NULL;

	if(argc < 3) {
		Usage(argv[0]);
		exit(1);
	}

	if( m_map_file( argv[1], &sFile ) == NULL ) {
		error_print("Invalid Path: %s\n", 0, argv[1]);
	}


	size = atoi(argv[2]);
	if( size )  {
		if( size < 0 ) {
			error_print( 
				"Cannot accept a negative number: %s\n", 
				0, argv[2] );
		}
		else if( size > INT_MAX ) {
			error_print(
				"Oversized integer size given: %s\nReverting to INT_MAX", 
				0, argv[2]);
		}
	}
	else {
		error_print("Invalid integer size given: %s\n", 0, argv[2]);
	}

	printf("Executable = %s\nSpecified TLS section size = 0x%X (%d)\n",
		argv[1],size,size);
	
	psNtHeaders = GetNtHeaders( &sFile );
	
	lpEntry = (void *)psNtHeaders->OptionalHeader.AddressOfEntryPoint;

	

	if( ( lpRealEntry = 
		(unsigned char *)VirtualAddressToFilePtrReal( lpEntry, &sFile ) 
		) == NULL ) {
			return 0;
	}

	lpEntry = (void *)((unsigned int)lpEntry + 
		psNtHeaders->OptionalHeader.ImageBase);

	memcpy( &ucCode[24], &lpEntry, 4 );
	
	memcpy( &ucCode[28], lpRealEntry, 5);
	
	AddTLSToPE( &sFile, size, ucCode, sizeof(ucCode) );
	iFilenameSize = strlen( sFile.lpszFilename );
	lpszOutFileName = (char *)calloc( iFilenameSize + 2, 1);
	lpszFileNameTmp = sFile.lpszFilename;
	lpszOutFileNameTmp = lpszOutFileName;
	while( iFilenameSize-- ) {
		if( *(lpszFileNameTmp) == '.' ) {
			*lpszOutFileName++ = '_';
		}
		*lpszOutFileName++ = *lpszFileNameTmp++;
	}
	m_write_file( &sFile, lpszOutFileNameTmp );
	return 1;
}
#pragma optimize("", on)