/*
ATLSWC - AddTLSSection With Code
Copyright (C) 2012  George Nicolaou nicolaou.george{at}gmail{dot}com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "memory.h"
#include "include.h"
#include <malloc.h>

void * m_map_file( char * lpszFilename, PFILE_IN_MEMORY pFile )
{
	FILE * hFile;
	int iFileSize;
	char * lpBuffer;

	if ( ( hFile = fopen( lpszFilename, "rb" ) ) != NULL ) {
		fseek( hFile, 0, SEEK_END );
		iFileSize = ftell( hFile );
		fseek( hFile, 0, SEEK_SET );
		lpBuffer = (char *)malloc( iFileSize + 1 );
		if( fread( lpBuffer, sizeof(char), iFileSize, hFile ) == 
			(size_t)iFileSize ) {
				fclose( hFile );
				if( pFile != NULL ) {
					pFile->lSize = iFileSize;
					pFile->lpFileBuffer = lpBuffer;
					pFile->lpszFilename = lpszFilename;
			}
				return (void *)lpBuffer;
		}
		free( lpBuffer );
		fclose( hFile );
		error_print("Error reading file", NULL );
	}
	error_print("Error reading file", NULL );
}

int m_write_file( PFILE_IN_MEMORY pFile, char * lpszNewFileName )
{
	FILE * hFile;
	if( lpszNewFileName == NULL ) {
		lpszNewFileName = pFile->lpszFilename;
	}

	if( ( hFile = fopen( lpszNewFileName, "wb" ) ) == NULL ) {
		error_print( "Error opening output file: %s\n", 0, lpszNewFileName );
	}

	if( fwrite( pFile->lpFileBuffer, 1, pFile->lSize, hFile ) != pFile->lSize ) {
		error_print( "Not enough data written\n", 0 );
	}

	fclose( hFile );
	return 1;
}